function [a,iter,nao_clas]=Batch_perceptron(X,margem,a_ini,n)
% Argumentos de entrada da funo
%  X:       matriz lxN cujas colunas so os vetores a serem classificados
%Para o exerccio proposto X  2x20 que aumentada fica 3x20
%  margem:  vetor N-dimensional cujo i-th  componente contem a etiqueta
%           da classe a qual o i-th vetor pertence (+1 ou -1).
%  a_ini:   vetor l-dimensional de pesos inicial.
%  n:       taxa de aprendizado.
%  theta:   condio de parada
%
% Argumentos de sada
%  a:       vetor l-dimensional de pesos final
%  iter:    nmero de iteraes
%  nao_clas: nmero de vetores no classificados.

[l,N]=size(X);
max_iter=20000; % Nmero mxima de iteraes permitido

a=a_ini;        % Inicializao do vetor de pesos
iter=0;         % Contador de iteraes

nao_clas=N;     % Inicializao do nmero de vetores no classificados
                %S para entrar no While

while(nao_clas>0)&&(iter<max_iter)
    iter=iter+1;
    nao_clas=0;
    
    gradi=zeros(l,1); % clculo do termo gradiente nas 3 dimenses 
                      %(2-D aumentada), aqui nenhum termo ainda 
                      %no-classificado (nao_class=0) logo gradi=0
    for i=1:N
        if((X(:,i)'*a)*margem(i)<0)%se etiquetado como -1 (caso d positivo, 
                     %para margem negativa ento j est classificado certo)
            nao_clas=nao_clas+1;
            gradi=gradi+n*(-margem(i)*X(:,i));%o menos faz J=gradi ser 
            %positivo sempre que a*X <0 indicando ponto X ainda no classificado
        end
    end
    
    if(iter==1)
        fprintf('\n Pontos no classificados na primeira iterao %g \n',nao_clas);        
    end
    
    a=a-gradi; % Atualizando pesos
end
end