%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Tcnicas Clssicas de Reconhecimento de Padres
%UFMG         2015/2  
%Algoritmo do Perceptron
%Computer Exercises - Exerccio 2 - Captulo 5 - Pattern Classification - Duda, Hart & Stork
%Adrielle C. Santana
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all
x1_w1=[0.1; 6.8; -3.5; 2.0; 4.1; 3.1; -0.8; 0.9; 5.0; 3.9];
x2_w1=[1.1; 7.1; -4.1; 2.7; 2.8; 5.0; -1.3; 1.2; 6.4; 4.0];
w1=[x1_w1 x2_w1];
x1_w2=[7.1; -1.4; 4.5; 6.3; 4.2; 1.4; 2.4; 2.5; 8.4; 4.1];
x2_w2=[4.2; -4.3; 0.0; 1.6; 1.9; -3.2; -4.0; -6.1; 3.7; -2.2];
w2=[x1_w2 x2_w2];
x1_w3=[-3.0; 0.5; 2.9; -0.1; -4.0; -1.3; -3.4; -4.1; -5.1; 1.9];
x2_w3=[-2.9; 8.7; 2.1; 5.2; 2.2; 3.7; 6.2; 3.4; 1.6; 5.1];
w3=[x1_w3 x2_w3];

X1=[w1; w2];
X2=[w3; w2];

%Traa dados exerccio 2 letra 'a'
figure (1)
plot(x1_w1, x2_w1, 'ro');
hold on
plot(x1_w2, x2_w2, 'b*');
xlabel('x1')
ylabel('x2')
legend('w1','w2')
hold off

%Traa dados exerccio 2 letra 'b'
figure (2)
plot(x1_w3, x2_w3, 'ro');
hold on
plot(x1_w2, x2_w2, 'b*');
xlabel('x1')
ylabel('x2')
legend('w3','w2')
hold off

% -- Normalizao  mdia e ao desvio padro -- %
media1 = mean(X1);
desvio1 = std(X1);
t1 = ones(length(X1), 1);
X1_norm = (X1 - (t1 * media1)) ./ (t1 * desvio1);
X1 = X1_norm;

media2 = mean(X2);
desvio2 = std(X2);
t2 = ones(length(X2), 1);
X2_norm = (X2 - (t2 * media2)) ./ (t2 * desvio2);
X2 = X2_norm;

%taxa de aprendizado
n=0.1;

%Vetor para classificao pela funo discriminante linear
margem1 = [-ones(length(w1),1); ones(length(w2),1)]';
margem2 = [-ones(length(w3),1); ones(length(w2),1)]';

%Criao de terceira dimenso de dados
X2 = [ones(length(margem2), 1) X2]';
X1 = [ones(length(margem1), 1) X1]';

%vetor de pesos iniciais
a_ini=ones(3,1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ITEM a
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[a,iter1,nao_clas]=Batch_perceptron(X1,margem1,a_ini,n)

novow1 =[];
novow2 =[];
disc_fun = X1' * a;

for i=1:length(disc_fun)
	if disc_fun(i) <= 0
		novow1 = [novow1 X1(:,i)];
	else
		novow2 = [novow2 X1(:,i)];
	end
end

%Removendo terceira dimenso;
novow1 = novow1(2:3,:);
novow2 = novow2(2:3,:);

% Plotando a superficie de separacao
%eixoX1 = linspace(-2.5,2,20);
%m=a(3,1)/a(2,1); %inclinao do vetor de separao
%eixoX2 = -(m.*eixoX1);

% Classificacao dos dados na aproximacao disc_fun = X * a
figure(3)
plot(novow1(1,:), novow1(2,:), 'om ');
hold on
plot(novow2(1,:), novow2(2,:), '*g');
%hold on
%plot(eixoX1, eixoX2,'-k', 'LineWidth', 2);
xlabel('x1')
ylabel('x2')
legend('w1','w2')
title(['Dados classificados usando a aproximacao X*a e ', num2str(iter1), ' iteraes'])
hold off
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ITEM b
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[a,iter2,nao_clas]=Batch_perceptron(X2,margem2,a_ini,n)

novow3 =[];
novow2 =[];
disc_fun = X2' * a;

for i=1:length(disc_fun)
	if disc_fun(i) <= 0
		novow3 = [novow3 X2(:,i)];
	else
		novow2 = [novow2 X2(:,i)];
	end
end

%Removendo terceira dimenso;
novow3 = novow3(2:3,:);
novow2 = novow2(2:3,:);

% Plotando a superficie de separacao
%eixoX1 = linspace(-2.5,2,20);
%m=a(3,1)/a(2,1); %inclinao do vetor de separao
%eixoX2 = -(m.*eixoX1);

% Classificacao dos dados na aproximacao disc_fun = X * a
figure(4)
plot(novow3(1,:), novow3(2,:), 'om');
hold on
plot(novow2(1,:), novow2(2,:), '*g');
%hold on
%plot(eixoX1, eixoX2,'-k', 'LineWidth', 2);
xlabel('x1')
ylabel('x2')
legend('w3','w2')
title(['Dados classificados usando a aproximacao X*a e ', num2str(iter2), ' iteraes'])
hold off
