%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Tcnicas Clssicas de Reconhecimento de Padres
%UFMG         2015/2  
%Algoritmo do Pocket-Perceptron
%Computer Exercises - Exerccio 3 - Pattern Classification - Duda, Hart & Stork
%Adrielle C. Santana
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all
x1_w1=[0.1; 6.8; -3.5; 2.0; 4.1; 3.1; -0.8; 0.9; 5.0; 3.9];
x2_w1=[1.1; 7.1; -4.1; 2.7; 2.8; 5.0; -1.3; 1.2; 6.4; 4.0];
w1=[x1_w1 x2_w1];
x1_w3=[-3.0; 0.5; 2.9; -0.1; -4.0; -1.3; -3.4; -4.1; -5.1; 1.9];
x2_w3=[-2.9; 8.7; 2.1; 5.2; 2.2; 3.7; 6.2; 3.4; 1.6; 5.1];
w3=[x1_w3 x2_w3];

X=[w1; w3];

%Traa dados exerccio 2 letra 'a'
figure (1)
plot(x1_w1, x2_w1, 'ro');
hold on
plot(x1_w3, x2_w3, 'b*');
title('Dados de Treinamento')
xlabel('x1')
ylabel('x2')
legend('w1','w3')
hold off

% -- Normalizao  mdia e ao desvio padro -- %
media = mean(X);
desvio = std(X);
t = ones(length(X), 1);
X_norm = (X - (t * media)) ./ (t * desvio);
X = X_norm;

%Vetor para classificao pela funo discriminante linear
vet_sol = [-ones(length(w1),1); ones(length(w3),1)]';

%Criao de terceira dimenso de dados
X = [ones(length(vet_sol), 1) X]';

%vetor de pesos iniciais do perceptron
a=zeros(3,1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[p,iter,contador,num_p,N]=Pocket_perceptron(X,vet_sol,a)

novow1 =[];
novow3 =[];
disc_fun = X' * p;

for i=1:length(disc_fun)
	if disc_fun(i) <= 0
		novow1 = [novow1 X(:,i)];
	else
		novow3 = [novow3 X(:,i)];
	end
end

%Removendo terceira dimenso;
novow1 = novow1(2:3,:);
novow3 = novow3(2:3,:);


% Classificacao dos dados na aproximacao disc_fun = X * a
figure(2)
plot(novow1(1,:), novow1(2,:), 'or');
hold on
plot(novow3(1,:), novow3(2,:), '*b');
hold on
xlabel('x1')
ylabel('x2')
legend('w1','w3')
title(['Dados classificados usando a aproximacao X*p e ', num2str(iter), ' iteraes'])
hold off

